<template>
    <div>
        <div class="grid grid-cols-2 sm:grid-cols-6 md:grid-cols-4 lg:grid-cols-5 xlg:grid-cols-10 gap-4 m-4">
            <div class="gif" v-for="gif in Gifs" :key="gif">
                <img class="w-auto h-60 rounded-lg" :src="gif" @click="agregaFavorito(gif)" alt>
            </div>
        </div>
    </div>
</template>
    
<script>
export default {
    name: 'ListGifComponent', 
    props: {
        Gifs: [],
        Favoritos: []
    },
    data() {
        return {
            favoritos: this.Favoritos,
        };
    },
    mounted() {
        //alert("mounted")
    },
    methods: {
        /**17/01/2024 KCASTILLO
         * Agrega el id de la imagen en el localstorage, validando que no este agregado en la la lista de de favoritos 
         * obtenida de props Favoritos si es null no hace nada
         * @param id 
         */
        agregaFavorito(id) {
            if (id) {
                const enFavoritos = this.favoritos?.includes(id)
                if (enFavoritos === true) {
                    this.$root.$emit('VisibleAlert', true, 'Gif ya es favorita');
                    setTimeout(() => this.$root.$emit('VisibleAlert', false, ''), 800)
                }
                if (enFavoritos === false) {
                    this.favoritos.push(id);
                    this.$root.$emit('VisibleAlert', true, 'Gif agregado a favoritos');
                    setTimeout(() => this.$root.$emit('VisibleAlert', false, ''), 800)
                    localStorage.setItem('favoritos', JSON.stringify(this.favoritos));
                    localStorage.setItem('SumFavoritos', this.favoritos.length);
                    this.$root.$emit('CountFavoritos',this.favoritos.length);
                }
            }
        }
    }
}
</script>
<style scoped>
.user-list {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
    flex: 1;
    padding: 0.7em;
}

.user {
    display: flex;
    flex-direction: column;
    flex: 1;
    padding: 0.5em;
    max-width: 250px;

}

.user-actions {
    flex: 1;
    display: flex;
    flex-direction: column;
    justify-content: center;
}

.avatar {
    display: flex;
    justify-content: center;
    align-self: center;
    width: 250px;
    height: 250px;

    &>img {
        background-attachment: fixed;
        background-size: cover;
        max-width: 250px;
    }
}

.gif:hover {
    transform: scale(1.2);
}
</style>